/**
 * POCDMT000040ManufacturedProduct2.java
 *
 * File generated from the cdaepsos2::POCDMT000040ManufacturedProduct2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos2;

import java.util.ArrayList;
import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class POCDMT000040ManufacturedProduct2.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.ManufacturedProduct", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"manufacturedLabeledDrug",
	"manufacturedMaterial",
	"manufacturerOrganization",
	"subjectOf1",
	"subjectOf2",
	"subjectOf3",
	"subjectOf4",
	"subjectOf5",
	"classCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.ManufacturedProduct")
public class POCDMT000040ManufacturedProduct2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> id;
	@XmlElement(name = "manufacturedLabeledDrug", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040LabeledDrug manufacturedLabeledDrug;
	@XmlElement(name = "manufacturedMaterial", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Material2 manufacturedMaterial;
	@XmlElement(name = "manufacturerOrganization", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040Organization manufacturerOrganization;
	@XmlElement(name = "subjectOf1", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> subjectOf1;
	@XmlElement(name = "subjectOf2", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject12> subjectOf2;
	@XmlElement(name = "subjectOf3", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> subjectOf3;
	@XmlElement(name = "subjectOf4", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject32> subjectOf4;
	@XmlElement(name = "subjectOf5", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.COCTMT230100UVSubject72 subjectOf5;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.RoleClassManufacturedProduct classCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().remove(id_elt);
	}
	
	/**
	 * Return manufacturedLabeledDrug.
	 * @return manufacturedLabeledDrug
	 */
	public net.ihe.gazelle.cda.POCDMT000040LabeledDrug getManufacturedLabeledDrug() {
	    return manufacturedLabeledDrug;
	}
	
	/**
	 * Set a value to attribute manufacturedLabeledDrug.
	 * @param manufacturedLabeledDrug.
	 */
	public void setManufacturedLabeledDrug(net.ihe.gazelle.cda.POCDMT000040LabeledDrug manufacturedLabeledDrug) {
	    this.manufacturedLabeledDrug = manufacturedLabeledDrug;
	}
	
	
	
	
	/**
	 * Return manufacturedMaterial.
	 * @return manufacturedMaterial
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Material2 getManufacturedMaterial() {
	    return manufacturedMaterial;
	}
	
	/**
	 * Set a value to attribute manufacturedMaterial.
	 * @param manufacturedMaterial.
	 */
	public void setManufacturedMaterial(net.ihe.gazelle.cdaepsos2.POCDMT000040Material2 manufacturedMaterial) {
	    this.manufacturedMaterial = manufacturedMaterial;
	}
	
	
	
	
	/**
	 * Return manufacturerOrganization.
	 * @return manufacturerOrganization
	 */
	public net.ihe.gazelle.cda.POCDMT000040Organization getManufacturerOrganization() {
	    return manufacturerOrganization;
	}
	
	/**
	 * Set a value to attribute manufacturerOrganization.
	 * @param manufacturerOrganization.
	 */
	public void setManufacturerOrganization(net.ihe.gazelle.cda.POCDMT000040Organization manufacturerOrganization) {
	    this.manufacturerOrganization = manufacturerOrganization;
	}
	
	
	
	
	/**
	 * Return subjectOf1.
	 * @return subjectOf1
	 */
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> getSubjectOf1() {
		if (subjectOf1 == null) {
	        subjectOf1 = new ArrayList<net.ihe.gazelle.medication2.COCTMT230100UVSubject222>();
	    }
	    return subjectOf1;
	}
	
	/**
	 * Set a value to attribute subjectOf1.
	 * @param subjectOf1.
	 */
	public void setSubjectOf1(List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> subjectOf1) {
	    this.subjectOf1 = subjectOf1;
	}
	
	
	
	/**
	 * Add a subjectOf1 to the subjectOf1 collection.
	 * @param subjectOf1_elt Element to add.
	 */
	public void addSubjectOf1(net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf1_elt) {
	    this.getSubjectOf1().add(subjectOf1_elt);
	}
	
	/**
	 * Remove a subjectOf1 to the subjectOf1 collection.
	 * @param subjectOf1_elt Element to remove
	 */
	public void removeSubjectOf1(net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf1_elt) {
	    this.getSubjectOf1().remove(subjectOf1_elt);
	}
	
	/**
	 * Return subjectOf2.
	 * @return subjectOf2
	 */
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject12> getSubjectOf2() {
		if (subjectOf2 == null) {
	        subjectOf2 = new ArrayList<net.ihe.gazelle.medication2.COCTMT230100UVSubject12>();
	    }
	    return subjectOf2;
	}
	
	/**
	 * Set a value to attribute subjectOf2.
	 * @param subjectOf2.
	 */
	public void setSubjectOf2(List<net.ihe.gazelle.medication2.COCTMT230100UVSubject12> subjectOf2) {
	    this.subjectOf2 = subjectOf2;
	}
	
	
	
	/**
	 * Add a subjectOf2 to the subjectOf2 collection.
	 * @param subjectOf2_elt Element to add.
	 */
	public void addSubjectOf2(net.ihe.gazelle.medication2.COCTMT230100UVSubject12 subjectOf2_elt) {
	    this.getSubjectOf2().add(subjectOf2_elt);
	}
	
	/**
	 * Remove a subjectOf2 to the subjectOf2 collection.
	 * @param subjectOf2_elt Element to remove
	 */
	public void removeSubjectOf2(net.ihe.gazelle.medication2.COCTMT230100UVSubject12 subjectOf2_elt) {
	    this.getSubjectOf2().remove(subjectOf2_elt);
	}
	
	/**
	 * Return subjectOf3.
	 * @return subjectOf3
	 */
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> getSubjectOf3() {
		if (subjectOf3 == null) {
	        subjectOf3 = new ArrayList<net.ihe.gazelle.medication2.COCTMT230100UVSubject222>();
	    }
	    return subjectOf3;
	}
	
	/**
	 * Set a value to attribute subjectOf3.
	 * @param subjectOf3.
	 */
	public void setSubjectOf3(List<net.ihe.gazelle.medication2.COCTMT230100UVSubject222> subjectOf3) {
	    this.subjectOf3 = subjectOf3;
	}
	
	
	
	/**
	 * Add a subjectOf3 to the subjectOf3 collection.
	 * @param subjectOf3_elt Element to add.
	 */
	public void addSubjectOf3(net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf3_elt) {
	    this.getSubjectOf3().add(subjectOf3_elt);
	}
	
	/**
	 * Remove a subjectOf3 to the subjectOf3 collection.
	 * @param subjectOf3_elt Element to remove
	 */
	public void removeSubjectOf3(net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf3_elt) {
	    this.getSubjectOf3().remove(subjectOf3_elt);
	}
	
	/**
	 * Return subjectOf4.
	 * @return subjectOf4
	 */
	public List<net.ihe.gazelle.medication2.COCTMT230100UVSubject32> getSubjectOf4() {
		if (subjectOf4 == null) {
	        subjectOf4 = new ArrayList<net.ihe.gazelle.medication2.COCTMT230100UVSubject32>();
	    }
	    return subjectOf4;
	}
	
	/**
	 * Set a value to attribute subjectOf4.
	 * @param subjectOf4.
	 */
	public void setSubjectOf4(List<net.ihe.gazelle.medication2.COCTMT230100UVSubject32> subjectOf4) {
	    this.subjectOf4 = subjectOf4;
	}
	
	
	
	/**
	 * Add a subjectOf4 to the subjectOf4 collection.
	 * @param subjectOf4_elt Element to add.
	 */
	public void addSubjectOf4(net.ihe.gazelle.medication2.COCTMT230100UVSubject32 subjectOf4_elt) {
	    this.getSubjectOf4().add(subjectOf4_elt);
	}
	
	/**
	 * Remove a subjectOf4 to the subjectOf4 collection.
	 * @param subjectOf4_elt Element to remove
	 */
	public void removeSubjectOf4(net.ihe.gazelle.medication2.COCTMT230100UVSubject32 subjectOf4_elt) {
	    this.getSubjectOf4().remove(subjectOf4_elt);
	}
	
	/**
	 * Return subjectOf5.
	 * @return subjectOf5
	 */
	public net.ihe.gazelle.medication2.COCTMT230100UVSubject72 getSubjectOf5() {
	    return subjectOf5;
	}
	
	/**
	 * Set a value to attribute subjectOf5.
	 * @param subjectOf5.
	 */
	public void setSubjectOf5(net.ihe.gazelle.medication2.COCTMT230100UVSubject72 subjectOf5) {
	    this.subjectOf5 = subjectOf5;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.RoleClassManufacturedProduct getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.RoleClassManufacturedProduct classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.ManufacturedProduct").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040ManufacturedProduct2 pOCDMT000040ManufacturedProduct2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040ManufacturedProduct2 != null){
   			cvm.validate(pOCDMT000040ManufacturedProduct2, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040ManufacturedProduct2.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040ManufacturedProduct2.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040ManufacturedProduct2.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II id: pOCDMT000040ManufacturedProduct2.getId()){
					net.ihe.gazelle.datatypes.II.validateByModule(id, _location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040LabeledDrug.validateByModule(pOCDMT000040ManufacturedProduct2.getManufacturedLabeledDrug(), _location + "/manufacturedLabeledDrug", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Material2.validateByModule(pOCDMT000040ManufacturedProduct2.getManufacturedMaterial(), _location + "/manufacturedMaterial", cvm, diagnostic);
			net.ihe.gazelle.cda.POCDMT000040Organization.validateByModule(pOCDMT000040ManufacturedProduct2.getManufacturerOrganization(), _location + "/manufacturerOrganization", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf1: pOCDMT000040ManufacturedProduct2.getSubjectOf1()){
					net.ihe.gazelle.medication2.COCTMT230100UVSubject222.validateByModule(subjectOf1, _location + "/subjectOf1[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.COCTMT230100UVSubject12 subjectOf2: pOCDMT000040ManufacturedProduct2.getSubjectOf2()){
					net.ihe.gazelle.medication2.COCTMT230100UVSubject12.validateByModule(subjectOf2, _location + "/subjectOf2[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.COCTMT230100UVSubject222 subjectOf3: pOCDMT000040ManufacturedProduct2.getSubjectOf3()){
					net.ihe.gazelle.medication2.COCTMT230100UVSubject222.validateByModule(subjectOf3, _location + "/subjectOf3[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.COCTMT230100UVSubject32 subjectOf4: pOCDMT000040ManufacturedProduct2.getSubjectOf4()){
					net.ihe.gazelle.medication2.COCTMT230100UVSubject32.validateByModule(subjectOf4, _location + "/subjectOf4[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication2.COCTMT230100UVSubject72.validateByModule(pOCDMT000040ManufacturedProduct2.getSubjectOf5(), _location + "/subjectOf5", cvm, diagnostic);
    	}
    }

}